/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>
#include "ToFCamera.h"

#if !defined(_MSC_VER) || _MSC_VER >= 1800
void ToFMeasurement400K_validity_Initialize(ToFMeasurement400K_validity* pVal)
{
  *pVal = (ToFMeasurement400K_validity)
  {
    .nCount = 1,    .arr =
    {
      depth_valid
    }
  };
}
#endif


flag ToFMeasurement400K_validity_IsConstraintValid(const ToFMeasurement400K_validity* pVal, int* pErrCode)
{

  flag ret = TRUE;
  int i1=0;
  *pErrCode=0;

  (void)pVal;

  ret = (1 <= pVal->nCount && pVal->nCount <= 400000);
  *pErrCode = ret ? 0 : ERR_ToFMeasurement400K_validity;
  i1 = 0;
  while (ret && (i1< pVal->nCount))
    {
      ret = Depth_validity_t_IsConstraintValid(&pVal->arr[i1], pErrCode);
      i1 = i1+1;
    }

  return ret;
}

flag ToFMeasurement400K_validity_Encode(const ToFMeasurement400K_validity* pVal, BitStream* pBitStrm, int* pErrCode,
                                        flag bCheckConstraints)
{
  flag ret = TRUE;
  int i1=0;

  ret = bCheckConstraints ? ToFMeasurement400K_validity_IsConstraintValid(pVal, pErrCode) : TRUE ;
  if (ret)
    {
      {
        asn1SccSint nCount1 = pVal->nCount;
        asn1SccSint curBlockSize1 = 0;
        asn1SccSint curItem1 = 0;
        while (nCount1 >= 0x4000)
          {
            if (nCount1 >= 0x10000)
              {
                curBlockSize1 = 0x10000;
                BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC4, 0, 0xFF);
              }
            else if (nCount1 >= 0xC000)
              {
                curBlockSize1 = 0xC000;
                BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC3, 0, 0xFF);
              }
            else if (nCount1 >= 0x8000)
              {
                curBlockSize1 = 0x8000;
                BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC2, 0, 0xFF);
              }
            else
              {
                curBlockSize1 = 0x4000;
                BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC1, 0, 0xFF);
              }

            for(i1=(int)curItem1; i1 < curBlockSize1 + curItem1; i1++)
              {
                ret = Depth_validity_t_Encode(&pVal->arr[i1], pBitStrm, pErrCode, FALSE);
              }
            curItem1 += curBlockSize1;
            nCount1 -= curBlockSize1;
          }

        if (nCount1 <= 0x7F)
          {
            BitStream_EncodeConstraintWholeNumber(pBitStrm, nCount1, 0, 0xFF);
          }
        else
          {
            BitStream_AppendBit(pBitStrm, 1);
            BitStream_EncodeConstraintWholeNumber(pBitStrm, nCount1, 0, 0x7FFF);
          }

        for(i1=(int)curItem1; i1 < curItem1 + nCount1; i1++)
          {
            ret = Depth_validity_t_Encode(&pVal->arr[i1], pBitStrm, pErrCode, FALSE);
          }
      }
    }

  return ret;
}

flag ToFMeasurement400K_validity_Decode(ToFMeasurement400K_validity* pVal, BitStream* pBitStrm, int* pErrCode)
{
  flag ret = TRUE;
  int i1=0;

  {
    asn1SccSint nCount1 = 0;
    asn1SccSint curBlockSize1 = 0;
    asn1SccSint curItem1 = 0;
    pVal->nCount = 0;
    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nCount1, 0, 0xFF);
    *pErrCode = ret ? 0 : 273416193;
    if (ret)
      {
        while(ret && (nCount1 & 0xC0)==0xC0)
          {
            if (nCount1 == 0xC4)
              {
                curBlockSize1 = 0x10000;
              }
            else if (nCount1 == 0xC3)
              {
                curBlockSize1 = 0xC000;
              }
            else if (nCount1 == 0xC2)
              {
                curBlockSize1 = 0x8000;
              }
            else if (nCount1 == 0xC1)
              {
                curBlockSize1 = 0x4000;
              }
            else
              {
                *pErrCode = 541851649;
                return FALSE;
              }
            if (curItem1 + curBlockSize1 > 400000)
              {
                *pErrCode = 273416194;
                return FALSE;
              }

            for(i1=curItem1; ret && (i1 < curItem1 + curBlockSize1) ; i1++)
              {
                ret = Depth_validity_t_Decode(&pVal->arr[i1], pBitStrm, pErrCode);
              }

            if (ret)
              {
                pVal->nCount += (long)curBlockSize1;
                curItem1 += curBlockSize1;
                ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nCount1, 0, 0xFF);
                *pErrCode = ret ? 0 : 273416195;
              }
          }
        if (ret)
          {
            if ( (nCount1 & 0x80)>0)
              {
                asn1SccSint len2;
                nCount1 <<= 8;
                ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &len2, 0, 0xFF);
                *pErrCode = ret ? 0 : 273416196;
                if (ret)
                  {
                    nCount1 |= len2;
                    nCount1 &= 0x7FFF;
                  }
              }
            ret = ret && (curItem1 + nCount1 <= 400000);
            *pErrCode = ret ? 0 : 273416197;
            if (ret)
              {
                for(i1=curItem1; ret && (i1 < curItem1 + nCount1) ; i1++)
                  {
                    ret = Depth_validity_t_Decode(&pVal->arr[i1], pBitStrm, pErrCode);
                  }
                if (ret)
                  {
                    pVal->nCount += (long)nCount1;
                  }
              }
          }
      }
  }

  return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void ToFRegion_Initialize(ToFRegion* pVal)
{
  *pVal = (ToFRegion)
  {
    .enable = FALSE,
     .region =
    {
      .offset_x = 0,
      .offset_y = 0,
      .size_x = 0,
      .size_y = 0
    }
  };
}
#endif


flag ToFRegion_IsConstraintValid(const ToFRegion* pVal, int* pErrCode)
{

  flag ret = TRUE;
  *pErrCode=0;

  (void)pVal;

  ret = T_Boolean_IsConstraintValid(&pVal->enable, pErrCode);
  if (ret)
    {
      ret = PlanarRegion_IsConstraintValid(&pVal->region, pErrCode);

    }

  return ret;
}

flag ToFRegion_Encode(const ToFRegion* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
  flag ret = TRUE;

  ret = bCheckConstraints ? ToFRegion_IsConstraintValid(pVal, pErrCode) : TRUE ;
  if (ret)
    {
      /*Encode enable */
      ret = T_Boolean_Encode(&pVal->enable, pBitStrm, pErrCode, FALSE);
      if (ret)
        {
          /*Encode region */
          ret = PlanarRegion_Encode(&pVal->region, pBitStrm, pErrCode, FALSE);

        }
    }

  return ret;
}

flag ToFRegion_Decode(ToFRegion* pVal, BitStream* pBitStrm, int* pErrCode)
{
  flag ret = TRUE;

  /*Decode enable */
  ret = T_Boolean_Decode(&pVal->enable, pBitStrm, pErrCode);
  if (ret)
    {
      /*Decode region */
      ret = PlanarRegion_Decode(&pVal->region, pBitStrm, pErrCode);

    }


  return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void ToFRange_Initialize(ToFRange* pVal)
{
  *pVal = (ToFRange)
  {
    .min_depth = 0.00000000000000000000E+000,
     .max_depth = 0.00000000000000000000E+000
  };
}
#endif


flag ToFRange_IsConstraintValid(const ToFRange* pVal, int* pErrCode)
{

  flag ret = TRUE;
  *pErrCode=0;

  (void)pVal;

  ret = T_Float_IsConstraintValid(&pVal->min_depth, pErrCode);
  if (ret)
    {
      ret = T_Float_IsConstraintValid(&pVal->max_depth, pErrCode);

    }

  return ret;
}

flag ToFRange_Encode(const ToFRange* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
  flag ret = TRUE;

  ret = bCheckConstraints ? ToFRange_IsConstraintValid(pVal, pErrCode) : TRUE ;
  if (ret)
    {
      /*Encode min_depth */
      ret = T_Float_Encode(&pVal->min_depth, pBitStrm, pErrCode, FALSE);
      if (ret)
        {
          /*Encode max_depth */
          ret = T_Float_Encode(&pVal->max_depth, pBitStrm, pErrCode, FALSE);

        }
    }

  return ret;
}

flag ToFRange_Decode(ToFRange* pVal, BitStream* pBitStrm, int* pErrCode)
{
  flag ret = TRUE;

  /*Decode min_depth */
  ret = T_Float_Decode(&pVal->min_depth, pBitStrm, pErrCode);
  if (ret)
    {
      /*Decode max_depth */
      ret = T_Float_Decode(&pVal->max_depth, pBitStrm, pErrCode);

    }


  return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void ToFConfiguration_Initialize(ToFConfiguration* pVal)
{
  *pVal = (ToFConfiguration)
  {
    .region_enabled = FALSE,
     .region =
    {
      .offset_x = 0,
      .offset_y = 0,
      .size_x = 0,
      .size_y = 0
    },
    .min_depth = 0.00000000000000000000E+000,
     .max_depth = 0.00000000000000000000E+000
  };
}
#endif


flag ToFConfiguration_IsConstraintValid(const ToFConfiguration* pVal, int* pErrCode)
{

  flag ret = TRUE;
  *pErrCode=0;

  (void)pVal;

  ret = T_Boolean_IsConstraintValid(&pVal->region_enabled, pErrCode);
  if (ret)
    {
      ret = PlanarRegion_IsConstraintValid(&pVal->region, pErrCode);
      if (ret)
        {
          ret = T_Float_IsConstraintValid(&pVal->min_depth, pErrCode);
          if (ret)
            {
              ret = T_Float_IsConstraintValid(&pVal->max_depth, pErrCode);

            }
        }
    }

  return ret;
}

flag ToFConfiguration_Encode(const ToFConfiguration* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
  flag ret = TRUE;

  ret = bCheckConstraints ? ToFConfiguration_IsConstraintValid(pVal, pErrCode) : TRUE ;
  if (ret)
    {
      /*Encode region_enabled */
      ret = T_Boolean_Encode(&pVal->region_enabled, pBitStrm, pErrCode, FALSE);
      if (ret)
        {
          /*Encode region */
          ret = PlanarRegion_Encode(&pVal->region, pBitStrm, pErrCode, FALSE);
          if (ret)
            {
              /*Encode min_depth */
              ret = T_Float_Encode(&pVal->min_depth, pBitStrm, pErrCode, FALSE);
              if (ret)
                {
                  /*Encode max_depth */
                  ret = T_Float_Encode(&pVal->max_depth, pBitStrm, pErrCode, FALSE);

                }
            }
        }
    }

  return ret;
}

flag ToFConfiguration_Decode(ToFConfiguration* pVal, BitStream* pBitStrm, int* pErrCode)
{
  flag ret = TRUE;

  /*Decode region_enabled */
  ret = T_Boolean_Decode(&pVal->region_enabled, pBitStrm, pErrCode);
  if (ret)
    {
      /*Decode region */
      ret = PlanarRegion_Decode(&pVal->region, pBitStrm, pErrCode);
      if (ret)
        {
          /*Decode min_depth */
          ret = T_Float_Decode(&pVal->min_depth, pBitStrm, pErrCode);
          if (ret)
            {
              /*Decode max_depth */
              ret = T_Float_Decode(&pVal->max_depth, pBitStrm, pErrCode);

            }
        }
    }


  return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void ToFMeasurement400K_distances_Initialize(ToFMeasurement400K_distances* pVal)
{
  *pVal = (ToFMeasurement400K_distances)
  {
    .nCount = 1,    .arr =
    {
      0.00000000000000000000E+000
    }
  };
}
#endif


flag ToFMeasurement400K_distances_IsConstraintValid(const ToFMeasurement400K_distances* pVal, int* pErrCode)
{

  flag ret = TRUE;
  int i1=0;
  *pErrCode=0;

  (void)pVal;

  ret = (1 <= pVal->nCount && pVal->nCount <= 400000);
  *pErrCode = ret ? 0 : ERR_ToFMeasurement400K_distances;
  i1 = 0;
  while (ret && (i1< pVal->nCount))
    {
      ret = T_Float_IsConstraintValid(&pVal->arr[i1], pErrCode);
      i1 = i1+1;
    }

  return ret;
}

flag ToFMeasurement400K_distances_Encode(const ToFMeasurement400K_distances* pVal, BitStream* pBitStrm, int* pErrCode,
    flag bCheckConstraints)
{
  flag ret = TRUE;
  int i1=0;

  ret = bCheckConstraints ? ToFMeasurement400K_distances_IsConstraintValid(pVal, pErrCode) : TRUE ;
  if (ret)
    {
      {
        asn1SccSint nCount1 = pVal->nCount;
        asn1SccSint curBlockSize1 = 0;
        asn1SccSint curItem1 = 0;
        while (nCount1 >= 0x4000)
          {
            if (nCount1 >= 0x10000)
              {
                curBlockSize1 = 0x10000;
                BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC4, 0, 0xFF);
              }
            else if (nCount1 >= 0xC000)
              {
                curBlockSize1 = 0xC000;
                BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC3, 0, 0xFF);
              }
            else if (nCount1 >= 0x8000)
              {
                curBlockSize1 = 0x8000;
                BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC2, 0, 0xFF);
              }
            else
              {
                curBlockSize1 = 0x4000;
                BitStream_EncodeConstraintWholeNumber(pBitStrm, 0xC1, 0, 0xFF);
              }

            for(i1=(int)curItem1; i1 < curBlockSize1 + curItem1; i1++)
              {
                ret = T_Float_Encode(&pVal->arr[i1], pBitStrm, pErrCode, FALSE);
              }
            curItem1 += curBlockSize1;
            nCount1 -= curBlockSize1;
          }

        if (nCount1 <= 0x7F)
          {
            BitStream_EncodeConstraintWholeNumber(pBitStrm, nCount1, 0, 0xFF);
          }
        else
          {
            BitStream_AppendBit(pBitStrm, 1);
            BitStream_EncodeConstraintWholeNumber(pBitStrm, nCount1, 0, 0x7FFF);
          }

        for(i1=(int)curItem1; i1 < curItem1 + nCount1; i1++)
          {
            ret = T_Float_Encode(&pVal->arr[i1], pBitStrm, pErrCode, FALSE);
          }
      }
    }

  return ret;
}

flag ToFMeasurement400K_distances_Decode(ToFMeasurement400K_distances* pVal, BitStream* pBitStrm, int* pErrCode)
{
  flag ret = TRUE;
  int i1=0;

  {
    asn1SccSint nCount1 = 0;
    asn1SccSint curBlockSize1 = 0;
    asn1SccSint curItem1 = 0;
    pVal->nCount = 0;
    ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nCount1, 0, 0xFF);
    *pErrCode = ret ? 0 : 273416198;
    if (ret)
      {
        while(ret && (nCount1 & 0xC0)==0xC0)
          {
            if (nCount1 == 0xC4)
              {
                curBlockSize1 = 0x10000;
              }
            else if (nCount1 == 0xC3)
              {
                curBlockSize1 = 0xC000;
              }
            else if (nCount1 == 0xC2)
              {
                curBlockSize1 = 0x8000;
              }
            else if (nCount1 == 0xC1)
              {
                curBlockSize1 = 0x4000;
              }
            else
              {
                *pErrCode = 541851650;
                return FALSE;
              }
            if (curItem1 + curBlockSize1 > 400000)
              {
                *pErrCode = 273416199;
                return FALSE;
              }

            for(i1=curItem1; ret && (i1 < curItem1 + curBlockSize1) ; i1++)
              {
                ret = T_Float_Decode(&pVal->arr[i1], pBitStrm, pErrCode);
              }

            if (ret)
              {
                pVal->nCount += (long)curBlockSize1;
                curItem1 += curBlockSize1;
                ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &nCount1, 0, 0xFF);
                *pErrCode = ret ? 0 : 273416200;
              }
          }
        if (ret)
          {
            if ( (nCount1 & 0x80)>0)
              {
                asn1SccSint len2;
                nCount1 <<= 8;
                ret = BitStream_DecodeConstraintWholeNumber(pBitStrm, &len2, 0, 0xFF);
                *pErrCode = ret ? 0 : 273416201;
                if (ret)
                  {
                    nCount1 |= len2;
                    nCount1 &= 0x7FFF;
                  }
              }
            ret = ret && (curItem1 + nCount1 <= 400000);
            *pErrCode = ret ? 0 : 273416202;
            if (ret)
              {
                for(i1=curItem1; ret && (i1 < curItem1 + nCount1) ; i1++)
                  {
                    ret = T_Float_Decode(&pVal->arr[i1], pBitStrm, pErrCode);
                  }
                if (ret)
                  {
                    pVal->nCount += (long)nCount1;
                  }
              }
          }
      }
  }

  return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void ToFMeasurement400K_Initialize(ToFMeasurement400K* pVal)
{
  *pVal = (ToFMeasurement400K)
  {
    .attributes =
    {
      .timestamp = -9223372036854775807LL,
      .validity = sample_empty,
      .attributes = {
        .nCount = 0,    .arr =
        {

        }
      }
    },
    .distances = {    .nCount = 1,    .arr =
      {
        0.00000000000000000000E+000
      }
    },
    .validity = {    .nCount = 1,    .arr =
      {
        depth_valid
      }
    },
    .region =
    {
      .offset_x = 0,
      .offset_y = 0,
      .size_x = 0,
      .size_y = 0
    }
  };
}
#endif


flag ToFMeasurement400K_IsConstraintValid(const ToFMeasurement400K* pVal, int* pErrCode)
{

  flag ret = TRUE;
  *pErrCode=0;

  (void)pVal;

  ret = SampleAttributes_IsConstraintValid(&pVal->attributes, pErrCode);
  if (ret)
    {
      ret = ToFMeasurement400K_distances_IsConstraintValid(&pVal->distances, pErrCode);
      if (ret)
        {
          ret = ToFMeasurement400K_validity_IsConstraintValid(&pVal->validity, pErrCode);
          if (ret)
            {
              ret = PlanarRegion_IsConstraintValid(&pVal->region, pErrCode);

            }
        }
    }

  return ret;
}

flag ToFMeasurement400K_Encode(const ToFMeasurement400K* pVal, BitStream* pBitStrm, int* pErrCode,
                               flag bCheckConstraints)
{
  flag ret = TRUE;

  ret = bCheckConstraints ? ToFMeasurement400K_IsConstraintValid(pVal, pErrCode) : TRUE ;
  if (ret)
    {
      /*Encode attributes */
      ret = SampleAttributes_Encode(&pVal->attributes, pBitStrm, pErrCode, FALSE);
      if (ret)
        {
          /*Encode distances */
          ret = ToFMeasurement400K_distances_Encode(&pVal->distances, pBitStrm, pErrCode, FALSE);
          if (ret)
            {
              /*Encode validity */
              ret = ToFMeasurement400K_validity_Encode(&pVal->validity, pBitStrm, pErrCode, FALSE);
              if (ret)
                {
                  /*Encode region */
                  ret = PlanarRegion_Encode(&pVal->region, pBitStrm, pErrCode, FALSE);

                }
            }
        }
    }

  return ret;
}

flag ToFMeasurement400K_Decode(ToFMeasurement400K* pVal, BitStream* pBitStrm, int* pErrCode)
{
  flag ret = TRUE;

  /*Decode attributes */
  ret = SampleAttributes_Decode(&pVal->attributes, pBitStrm, pErrCode);
  if (ret)
    {
      /*Decode distances */
      ret = ToFMeasurement400K_distances_Decode(&pVal->distances, pBitStrm, pErrCode);
      if (ret)
        {
          /*Decode validity */
          ret = ToFMeasurement400K_validity_Decode(&pVal->validity, pBitStrm, pErrCode);
          if (ret)
            {
              /*Decode region */
              ret = PlanarRegion_Decode(&pVal->region, pBitStrm, pErrCode);

            }
        }
    }


  return ret;
}

